#include "sighand.h"   /* itime() */
#include "spins.h"

/* nr=0,1,2,... -1=close, v2.20 less sys-calls, mpi_task 0 only */
void outtri(int nr,zahl a,zahl b){ /* write tridiagonal matrix */
    static FILE *ft=NULL, *fb=NULL;
    long t=itime();
    int r0=0;
    if (nr<=0) {
      if (ft) fclose(ft); if (fb) fclose(fb); ft=fb=NULL; if (nr<0) return;
    }
    if (nr<=1 && !ft) {
      ft=fopen("tmp/tri.txt","wt"); if (ft) setvbuf(ft,NULL,_IONBF,0);
      fb=fopen("tmp/tri.dat","wb"); if (fb) setvbuf(fb,NULL,_IONBF,0);
      if (!ft) { E0("fopen tmp/tri.txt"); return; }
      if (!fb) { E0("fopen tmp/tri.txt"); return; }
    }
    if (ft) fprintf(ft,"%3d %20.16f %20.16f %6.2fm\n",
                    nr, (double)a, (double)b, t/60.);
    if (fb)          r0=fwrite(&a,sizeof(zahl),1,fb); // ret=written_memb (1)
    if (fb && r0==1) r0=fwrite(&b,sizeof(zahl),1,fb);
    if (fb && r0!=1) E0("outtri write tri.dat");
    return;
}

/* restore tridiagonal matrix */
int loadtri(zahl *a, zahl *b, int n){
    FILE *f; int last=0;
    outtri(-1,0,0);
    f=fopen("tmp/tri.dat","rb");
    if(!f){E0("fopen(tmp/tri.dat)");return 0;}
    while(!feof(f) || last>=n){
      if(fread(a+last,sizeof(zahl),1,f)!=1)break;
      if(fread(b+last,sizeof(zahl),1,f)!=1)break;
      last++;
    }
    fclose(f);
    printf(" loadtri=%d",last);
    /* ToDo: call last times outtri */
    return last;
}

